
; #include <Array.au3>
#include <String.au3>

#cs

This script puts the source language into the target field of a TS file.

1. split by <message> and then by </message>
2. do a regex FR with source and translation

#ce

$fod = FileOpenDialog ("Select TS file", @ScriptDir, "TS files (*.ts)|Text files (*.txt)|All files (*.*)")

$fo = FileOpen ($fod, 16384)
$fr = FileRead ($fo)

; $fsd = FileSaveDialog ("Select output TS file name", @ScriptDir, "TS files (*.ts)|Text files (*.txt)|All files (*.*)", 18)
; $fwo = FileOpen ($fsd, 16385)

$fwo = FileOpen ($fod & "_new.ts", 16385)

$options1 = InputBox ("Which conversion?", "Select which conversion you'd like to perform on the TS file (0 = keep as is):" & @CRLF & @CRLF & "1. source [translation]" & @CRLF & "2. translation [source]" & @CRLF & "3. [source]", 1)

If $options1 > 3 Then
MsgBox (0, "Error", "Select either 0, 1, 2 or 3 for 'which conversion'.", 0)
Exit
EndIf

$options2 = InputBox ("Add numbers?", "Select which way you want to add numbers to strings, if any (0 = no numbers):" & @CRLF & @CRLF & "1. at the start of each string" & @CRLF & "2. at the end of each string", 1)

If $options2 > 2 Then
MsgBox (0, "Error", "Select either 0, 1 or 2 for 'add numbers'", 0)
Exit
EndIf

$firstsplit = StringSplit ($fr, "<message>", 1)

FileWrite ($fwo, $firstsplit[1])

For $i = 2 to $firstsplit[0]

$j = 0

If $i < 10 Then
$j = "000" & $i - 1
ElseIf $i < 100 Then
$j = "00" & $i - 1
ElseIf $i < 1000 Then
$j = "0" & $i - 1
ElseIf $i > 999 Then
$j = $i - 1
EndIf

$secondsplit = StringSplit ($firstsplit[$i], "</message>", 1)

$messagetail0 = _StringExplode ($firstsplit[$i], "</message>", 1)

$messagetail = $messagetail0[1]

If $options1 = 0 Then
$newmessage = StringRegExpReplace ($secondsplit[1], "(?s)(<source>)(.+?)(</source>)(.+?)(<translation>)(.+?)(</translation>)", "$1$2$3$4$5$6$7")
ElseIf $options1 = 1 Then
$newmessage = StringRegExpReplace ($secondsplit[1], "(?s)(<source>)(.+?)(</source>)(.+?)(<translation>)(.+?)(</translation>)", "$1$2$3$4$5$2 [$6]$7")
ElseIf $options1 = 2 Then
$newmessage = StringRegExpReplace ($secondsplit[1], "(?s)(<source>)(.+?)(</source>)(.+?)(<translation>)(.+?)(</translation>)", "$1$2$3$4$5$6 [$2]$7")
ElseIf $options1 = 3 Then
$newmessage = StringRegExpReplace ($secondsplit[1], "(?s)(<source>)(.+?)(</source>)(.+?)(<translation>)(.+?)(</translation>)", "$1$2$3$4$5[$2]$7")
EndIf

If $options2 = 0 Then
$newmessage = $newmessage
ElseIf $options2 = 1 Then
$newmessage = StringRegExpReplace ($newmessage, "(<translation.*?>)", "$1" & "{" &  $j & "} ")
ElseIf $options2 = 2 Then
$newmessage = StringReplace ($newmessage, "</translation>", " {" &  $j & "}</translation>")
EndIf

FileWrite ($fwo, "<message>" & $newmessage & "</message>" & $messagetail)

Next
